=== debian/changelog ===
clsparse (0.10.2.0-3) unstable; urgency=medium

  * Add patch fixing FTBFS with ppc64el.
    Thanks to Fernando Seiti Furusato for the patch (Closes: #844008)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 15 Nov 2016 11:55:35 +0000

clsparse (0.10.2.0-2) unstable; urgency=medium

  * Refresh patch queue.
  * Add patch fixing FTBFS with GNU Hurd and kFreeBSD.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 11 Nov 2016 16:52:52 +0000

clsparse (0.10.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #794552)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 05 Nov 2016 15:45:20 +0000
