=== debian/tests/control ===
Test-Command: cd $AUTOPKGTEST_TMP;
 cmake /usr/share/doc/clsparse-doc/examples -DUSE_SYSTEM_CL2HPP=ON; make
Restrictions: allow-stderr
Depends: @, cmake, g++ | c++-compiler, opencl-clhpp-headers
