=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clSPARSE-$1\.tar\.gz/ \
https://github.com/clMathLibraries/clSPARSE/tags .*/v?(\d\S*)\.tar\.gz
